﻿;- TODO 
;{
;		SQLite_Table_GetType
;		SQLite_Table_IsNull
;		...
;		_DatabaseTableList
;		_DatabaseFieldList
;		GetDatabaseFieldPos(name.s)
;		GetDatabaseFieldName(pos.l)
;		
;		_ExamineDatabaseFields
;		_NextDatabaseField
;		_DatabaseField
;		
;		SQLite3_GetLibVersion
;		
;		DatabaseFree
;		
;}
;{- PB_Object_
Prototype   PB_Object_GetOrAllocate   (Objects, Object.l) 
Prototype   PB_Object_GetObject       (Objects, Object.l) 
Prototype   PB_Object_IsObject        (Objects, Object.l) 
Prototype   PB_Object_EnumerateAll    (Objects, ObjectEnumerateAllCallback, *VoidData) 
Prototype   PB_Object_EnumerateStart  (Objects) 
Prototype   PB_Object_EnumerateNext   (Objects, *Object.LONG) 
Prototype   PB_Object_EnumerateAbort  (Objects) 
Prototype   PB_Object_Free            (Objects, Object.l) 
Prototype.l PB_Object_Init            (StructureSize.l, IncrementStep.l, ObjectFreeFunction) 
Prototype   PB_Object_GetThreadMemory (MemoryID.l) 
Prototype.l PB_Object_InitThreadMemory(Size.l, InitFunction, EndFunction) 
;}

;{- Object_
Global Object_GetOrAllocate   .PB_Object_GetOrAllocate 
Global Object_GetObject       .PB_Object_GetObject 
Global Object_IsObject        .PB_Object_IsObject 
Global Object_EnumerateAll    .PB_Object_EnumerateAll 
Global Object_EnumerateStart  .PB_Object_EnumerateStart 
Global Object_EnumerateNext   .PB_Object_EnumerateNext 
Global Object_EnumerateAbort  .PB_Object_EnumerateAbort 
Global Object_Free            .PB_Object_Free 
Global Object_Init            .PB_Object_Init 
Global Object_GetThreadMemory .PB_Object_GetThreadMemory 
Global Object_InitThreadMemory.PB_Object_InitThreadMemory 
;}

;{- !EXTRN
!EXTRN _PB_Object_GetOrAllocateID@8 
!EXTRN _PB_Object_GetObject@8 
!EXTRN _PB_Object_IsObject@8 
!EXTRN _PB_Object_EnumerateAll@12 
!EXTRN _PB_Object_EnumerateStart@4 
!EXTRN _PB_Object_EnumerateNext@8 
!EXTRN _PB_Object_EnumerateAbort@4 
!EXTRN _PB_Object_FreeID@8 
!EXTRN _PB_Object_Init@12 
!EXTRN _PB_Object_GetThreadMemory@4 
!EXTRN _PB_Object_InitThreadMemory@12 
;}

;{- !MOV
!MOV [v_Object_GetOrAllocate]   , _PB_Object_GetOrAllocateID@8 
!MOV [v_Object_GetObject]       , _PB_Object_GetObject@8 
!MOV [v_Object_IsObject]        , _PB_Object_IsObject@8 
!MOV [v_Object_EnumerateAll]    , _PB_Object_EnumerateAll@12 
!MOV [v_Object_EnumerateStart]  , _PB_Object_EnumerateStart@4 
!MOV [v_Object_EnumerateNext]   , _PB_Object_EnumerateNext@8 
!MOV [v_Object_EnumerateAbort]  , _PB_Object_EnumerateAbort@4 
!MOV [v_Object_Free]            , _PB_Object_FreeID@8 
!MOV [v_Object_Init]            , _PB_Object_Init@12 
!MOV [v_Object_GetThreadMemory] , _PB_Object_GetThreadMemory@4 
!MOV [v_Object_InitThreadMemory], _PB_Object_InitThreadMemory@12
;}

Structure S_SQLite_Object
	hDatabase.l
	;Query
	Result_Handle.l
	Result_Rows.l
	Result_Cols.l
	Result_Pos.l
	Result_Stmt.l
	Result_StmtBool.l
	Result_Bof.l
	Result_Eof.l
	;Database Tables
	DatabaseTables_Handle.l
	DatabaseTables_Rows.l
	DatabaseTables_Pos.l
	DatabaseTables_Stmt.l
	DatabaseTables_StmtBool.l
	DatabaseTables_Bof.l
	DatabaseTables_Eof.l
	;Database Fields
	DatabaseFields_Stmt.l
EndStructure

Macro DATABASE_ID(db)
  Object_GetObject(SQLiteObjects, db)
EndMacro
Macro DATABASE_IS(db)
  Object_IsObject(SQLiteObjects, db) 
EndMacro
Macro DATABASE_NEW(db)
  Object_GetOrAllocate(SQLiteObjects, db)
EndMacro
Macro DATABASE_FREE(db)
  Object_Free(SQLiteObjects, db)
EndMacro
Macro DATABASE_INIT(hCloseFunction)
  Object_Init(SizeOf(S_SQLite_Object), 1, hCloseFunction)
EndMacro

DeclareDLL.l SQLite_CloseDatabase(database.l)
;- Database.lib - Normal Set
ProcedureDLL.l SQLite_InitDatabase()
	Global SQLiteObjects.l
	Global SQLiteLastErr.s
	
	SQLiteObjects = DATABASE_INIT(@SQLite_CloseDatabase())
  If SQLiteObjects
    ProcedureReturn #True
  EndIf
EndProcedure
ProcedureDLL.l SQLite_IsDatabase(database.l)
  ProcedureReturn DATABASE_IS(database)
EndProcedure
ProcedureDLL.s SQLite_DatabaseError()
  ProcedureReturn SQLiteLastErr
EndProcedure
ProcedureDLL.l SQLite_CloseDatabase(database.l)
  Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	; Free PureBasic Object
	If *self
;  		If *self\Result_Handle
;  			sqlite3_free_table(*self\Result_Handle)
;  		EndIf
		If *self\DatabaseTables_Handle
			sqlite3_free_table(*self\DatabaseTables_Handle)
		EndIf
		hResult = sqlite3_close(*self\hDatabase)
		DATABASE_FREE(database)
		ProcedureReturn hResult
	EndIf
EndProcedure
ProcedureDLL.l SQLite_OpenDatabase(database.l, DataBaseName.s)
	Protected db.l
	Protected *self.S_SQLite_Object
	If sqlite3_open(DataBaseName, @db) = #SQLITE_OK
		*self 					= DATABASE_NEW(database)
		*self\hDatabase	=	db
		ProcedureReturn *self
	EndIf
EndProcedure

ProcedureDLL.l SQLite_DatabaseQuery(database.l, query.s)
  Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  
  If *self
		If *self\Result_Handle
			sqlite3_free_table(*self\Result_Handle)
		EndIf
  	hResult = sqlite3_get_table(*self\hDatabase, query, @lResultsPtr, @lRows, @lCols, @lReturnValue)
  	If hResult = #SQLITE_OK
  		*self\Result_Handle 	= lResultsPtr
  		*self\Result_Rows 		= lRows
  		*self\Result_Cols 		= lCols
  		*self\Result_Pos 			= 1
  		SQLiteLastErr 				= "Success"
			
			sqlite3_finalize(*self\Result_Stmt)
			sqlite3_prepare(*self\hDatabase, query, Len(query),@ppStmt,0)
  		*self\Result_Stmt 		= ppStmt
  		*self\Result_StmtBool = #False
  	Else
  	  If lReturnValue
  		SQLiteLastErr = PeekS(lReturnValue, -1, #PB_UTF8)
  	  EndIf
  	EndIf
  EndIf
EndProcedure
ProcedureDLL.l SQLite_DatabaseUpdate(database.l, query.s)
  Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  If *self And query
  	hResult = sqlite3_exec(*self\hDatabase, query, 0, 0, @ReturnValue)
  	If hResult = #SQLITE_OK
			*self\Result_Handle = #Null
			*self\Result_Rows 	= #Null
			*self\Result_Cols 	= #Null
		  *self\Result_Pos 		= #Null
    	SQLiteLastErr 			= "Success"
  	Else
  		SQLiteLastErr = PeekS(ReturnValue, -1, #PB_UTF8)
  	EndIf
  EndIf
EndProcedure
ProcedureDLL.l SQLite_DatabaseColumns(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		ProcedureReturn *self\Result_Cols
	EndIf
EndProcedure
ProcedureDLL.s SQLite_DatabaseColumnName(database.l, column.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	Protected Address.l, AddrInc.l, Inc_a.l
	If *self
		CompilerIf #PB_Compiler_Unicode = #False
		  ProcedureReturn PeekS(PeekL(*self\Result_Handle + column  * 4))
		CompilerElse
		  ProcedureReturn PeekS(PeekL(*self\Result_Handle + column  * 4),-1, #PB_UTF8)
		CompilerEndIf
	EndIf
EndProcedure
ProcedureDLL.l SQLite_DatabaseColumnType(database.l, column.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		If *self\Result_StmtBool = #False
			sqlite3_step(*self\Result_Stmt)
			*self\Result_StmtBool = #True
		EndIf
		Select sqlite3_column_type(*self\Result_Stmt, column)
			Case #SQLITE_INTEGER ; 1
				ProcedureReturn 1
			Case #SQLITE_FLOAT   ; 2
				ProcedureReturn 3
			Case #SQLITE_TEXT    ; 3
				ProcedureReturn 2
			Case #SQLITE_BLOB    ; 4
				ProcedureReturn 0
			Case #SQLITE_NULL    ; 5
				ProcedureReturn 0
			Default
				ProcedureReturn 555
		EndSelect
	EndIf
EndProcedure

ProcedureDLL.l SQLite_FirstDatabaseRow(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\Result_BOF = #True
		*self\Result_EOF = #False
		*self\Result_Pos = 0
	EndIf
EndProcedure
ProcedureDLL.l SQLite_NextDatabaseRow(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\Result_BOF = #False
		*self\Result_EOF = #False
		If *self\Result_Pos < *self\Result_Rows - 1
			*self\Result_Pos + 1
		Else
			*self\Result_Pos = *self\Result_Rows - 1
			*self\Result_EOF = #True
		EndIf
	EndIf
EndProcedure
ProcedureDLL.l SQLite_PreviousDatabaseRow(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\Result_BOF = #False
		*self\Result_EOF = #False
		If *self\Result_Pos > 0
			*self\Result_Pos - 1
		Else
			*self\Result_Pos = 0
			*self\Result_BOF = #True
		EndIf
	EndIf
EndProcedure

ProcedureDLL.l SQLite_ExamineDatabaseDrivers()
  ProcedureReturn #False
EndProcedure
ProcedureDLL.l SQLite_NextDatabaseDriver()
  ProcedureReturn #False
EndProcedure
ProcedureDLL.s SQLite_DatabaseDriverName()
  ProcedureReturn #NULL$
EndProcedure
ProcedureDLL.s SQLite_DatabaseDriverDescription()
  ProcedureReturn #NULL$
EndProcedure

ProcedureDLL.f SQLite_GetDatabaseFloat(database.l, column.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  If *self
	  Address = *self\Result_Handle
	  AddrInc = *self\Result_Cols * 4 
	  If column > *self\Result_Cols - 1
	  	column = *self\Result_Cols -1
	  EndIf
	  If column < 0
	  	column = 0
	  EndIf
  	For Row.l  = 0 To *self\Result_Pos
			Address  + AddrInc
		Next
		CompilerIf #PB_Compiler_Unicode = #False
		  ProcedureReturn ValF(PeekS(PeekL(Address + column  * 4)))
		CompilerElse
		  ProcedureReturn ValF(PeekS(PeekL(Address + column  * 4),-1, #PB_UTF8))
		CompilerEndIf
  EndIf
EndProcedure
ProcedureDLL.l SQLite_GetDatabaseLong(database.l, column.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  If *self
	  Address = *self\Result_Handle
	  AddrInc = *self\Result_Cols * 4 
	  If column > *self\Result_Cols - 1
	  	column = *self\Result_Cols -1
	  EndIf
	  If column < 0
	  	column = 0
	  EndIf
  	For Row.l  = 0 To *self\Result_Pos
			Address  + AddrInc
		Next
		
	  ProcedureReturn Val(PeekS(PeekL(Address + column  * 4),-1, #PB_Ascii))
  EndIf
EndProcedure
ProcedureDLL.s SQLite_GetDatabaseString(database.l, column.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  If *self
	  Address = *self\Result_Handle
	  AddrInc = *self\Result_Cols * 4 
	  If column > *self\Result_Cols - 1
	  	column = *self\Result_Cols -1
	  EndIf
	  If column < 0
	  	column = 0
	  EndIf
  	For Row.l  = 0 To *self\Result_Pos
			Address  + AddrInc
		Next
		CompilerIf #PB_Compiler_Unicode = #False
		  ProcedureReturn PeekS(PeekL(Address + column  * 4))
		CompilerElse
		  ProcedureReturn PeekS(PeekL(Address + column  * 4),-1, #PB_UTF8)
		CompilerEndIf
  EndIf
EndProcedure
ProcedureDLL.l SQLite_GetDatabaseBlob(database.l, column.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  If *self
	  Address = *self\Result_Handle
	  AddrInc = *self\Result_Cols * 4 
	  If column > *self\Result_Cols - 1
	  	column = *self\Result_Cols -1
	  EndIf
	  If column < 0
	  	column = 0
	  EndIf
  	For Row.l  = 0 To *self\Result_Pos -1
			Address  + AddrInc
		Next
		ProcedureReturn PeekL(Address + column  * 4)
  EndIf
EndProcedure
ProcedureDLL.d SQLite_GetDatabaseDouble(database.l, column.l)
	Protected Double.d
	Double = SQLite_GetDatabaseLong(database.l, column.l)
	ProcedureReturn Double
EndProcedure
ProcedureDLL.q SQLite_GetDatabaseQuad(database.l, column.l)
	Protected Quad.q
	Quad = SQLite_GetDatabaseLong(database.l, column.l)
	ProcedureReturn Quad
EndProcedure

ProcedureDLL.l SQLite_OpenDatabaseRequester(database.l)
	Protected SQLiteId.l
	Protected W_title.s, W_Id.l
	Protected glogo, gPath, gBrowse, gOpen, gOk, gCancel
	Protected pFile.s

	W_title = "SQLite Connector for PureBasic 4.0"
	W_Id = OpenWindow(#PB_Any,0,0,337,160, W_title,#PB_Window_Invisible|#PB_Window_ScreenCentered)
	If W_Id
    SetWindowLong_(WindowID(W_Id), #GWL_EXSTYLE, #WS_EX_TOOLWINDOW)
    
    If CreateGadgetList(WindowID(W_Id))
      
      glogo	=	CatchImage(#PB_Any,?SQLiteLogo)
      ImageGadget	(#PB_Any, 005, 005, 327, 097, ImageID(glogo))

      TextGadget	(#PB_Any, 015, 115, 060, 018, "Path :")
      gPath				=	StringGadget(#PB_Any,		52, 110, 200,	 22, "")
      gBrowse			=	ButtonGadget(#PB_Any,	 253, 110,	80,	 22, "Browse")
      
      gOpen       = ButtonGadget(#PB_Any,    5, 140, 109,  22, "Open")
      gOk         = ButtonGadget(#PB_Any,  115, 140, 109,  22, "OK")
      gCancel     = ButtonGadget(#PB_Any,  225, 140, 109,  22, "Cancel")
      
      HideWindow(W_Id, #False)
    EndIf  
    Repeat
      Select WaitWindowEvent()
        Case #PB_Event_CloseWindow
          Break
        Case #PB_Event_Gadget
          Select EventGadget()
            Case gBrowse
            	pFile = OpenFileRequester("Choose database to load","","SQLite3 Database|*.db;*.sdb;*.s2db;*.s3db|All files (*.*)|*.*",0)
            	If pFile
            		SetGadgetText(gPath, pFile)
            	EndIf
            Case gOpen
            	SQLiteId = SQLite_OpenDatabase(database, pFile)
            Case gOk
            	CloseWindow(W_Id)
            	ProcedureReturn SQLiteId
            Case gCancel
            	CloseWindow(W_Id)
            	SQLiteLastErr = "Requester canceled"
            	ProcedureReturn 0
          EndSelect
      EndSelect
    ForEver
    CloseWindow(W_Id)
	Else
		SQLiteLastErr = "Requester can't be opened."
		ProcedureReturn 0
	EndIf
EndProcedure


;- Database.lib - Extended Set
ProcedureDLL.l SQLite_DatabaseRows(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		ProcedureReturn *self\Result_Rows
	EndIf
EndProcedure
ProcedureDLL.l SQLite_LastDatabaseRow(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\Result_BOF = #False
		*self\Result_EOF = #True
		*self\Result_Pos = *self\Result_Rows - 1
	EndIf
EndProcedure
ProcedureDLL.l SQLite_GetDatabaseRowState(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		ProcedureReturn *self\Result_Pos
	EndIf
EndProcedure
; Tables
ProcedureDLL.l SQLite_ExamineDatabaseTables(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	Protected query.s
  If *self
		query = "SELECT name FROM sqlite_master where type = 'table';"
		If *self\DatabaseTables_Handle
			sqlite3_free_table(*self\DatabaseTables_Handle)
		EndIf
		hResult = sqlite3_get_table(*self\hDatabase, query, @lResultsPtr, @lRows, @lCols, @lReturnValue)
  	If hResult = #SQLITE_OK
  		*self\DatabaseTables_Handle 	= lResultsPtr
  		*self\DatabaseTables_Rows 		= lRows
  		*self\DatabaseTables_Pos 			= 1
  		SQLiteLastErr 								= "Success"
  		ProcedureReturn lRows
  	Else
  		SQLiteLastErr = PeekS(lReturnValue, -1, #PB_UTF8)
  		ProcedureReturn -1
  	EndIf
  EndIf
EndProcedure
ProcedureDLL.s SQLite_DatabaseTable(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  If *self
	  Address = *self\DatabaseTables_Handle
	  AddrInc = 1 * 4 
  	For Row.l  = 0 To *self\DatabaseTables_Pos
			Address  + AddrInc
		Next
		CompilerIf #PB_Compiler_Unicode = #False
		  ProcedureReturn PeekS(PeekL(Address))
		CompilerElse
		  ProcedureReturn PeekS(PeekL(Address),-1, #PB_UTF8)
		CompilerEndIf
  EndIf
EndProcedure
ProcedureDLL.l SQLite_FirstDatabaseTable(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\DatabaseTables_BOF = #True
		*self\DatabaseTables_EOF = #False
		*self\DatabaseTables_Pos = 0
	EndIf
EndProcedure
ProcedureDLL.l SQLite_NextDatabaseTable(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\DatabaseTables_BOF = #False
		*self\DatabaseTables_EOF = #False
		If *self\DatabaseTables_Pos < *self\DatabaseTables_Rows - 1
			*self\DatabaseTables_Pos + 1
		Else
			*self\DatabaseTables_Pos = *self\DatabaseTables_Rows - 1
			*self\DatabaseTables_EOF = #True
		EndIf
	EndIf
EndProcedure
ProcedureDLL.l SQLite_PreviousDatabaseTable(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\DatabaseTables_BOF = #False
		*self\DatabaseTables_EOF = #False
		If *self\DatabaseTables_Pos > 0
			*self\DatabaseTables_Pos - 1
		Else
			*self\DatabaseTables_Pos = 0
			*self\DatabaseTables_BOF = #True
		EndIf
	EndIf
EndProcedure
ProcedureDLL.l SQLite_LastDatabaseTable(database.l)
	Protected *self.S_SQLite_Object = DATABASE_ID(database) 
	If *self
		*self\DatabaseTables_BOF = #False
		*self\DatabaseTables_EOF = #True
		*self\DatabaseTables_Pos = *self\DatabaseTables_Rows - 1
	EndIf
EndProcedure

ProcedureDLL.s SQLite_GetLibVersion()
	ProcedureReturn PeekS(sqlite3_libversion(),-1,#PB_UTF8)
EndProcedure

ProcedureDLL.l TMP_SQLite_Parse(database.l)
  Protected *self.S_SQLite_Object = DATABASE_ID(database) 
  If *self
	  Address = *self\Result_Handle
	  AddrInc = *self\Result_Cols * 4 
		For Row.l  = 0 To *self\Result_Rows; -1
			For Col.l  = 0 To *self\Result_Cols -1
				Debug "--"+PeekS(PeekL(Address + Col  * 4))
			Next
			Address  + AddrInc
		Next
	EndIf	
EndProcedure

DataSection
	SQLiteLogo:
		IncludeBinary "sqlite.bmp"
EndDataSection

; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 487
; FirstLine = 63
; Folding = AAAAAAE5
; EnableXP
; UseMainFile = SQLite_Ex0.pb