﻿; --------------------------------------------------------- 
;  
;  File        : sqlite3.pbi 
;  Version     : 1.0
;  Language    : PureBasic 4.0
;  Description : SQLite 3.3.7 Wrapper 
;  Author      : flype (flype44@gmail.com)
;  Licence     : freeware / open-source
;  
;  sqlite      : http://www.sqlite.org
;  sqliteadmin : http://sqliteadmin.orbmu2k.de/
;  
; --------------------------------------------------------- 
;  
;  Update 1.0  	: 2006-09-17 (flype)
;  Update 1.1  	: 
;  Update 1.2  	: 
;  Update 1.3  	: 2007-01-13 (Progi1984)
;										passage de p-str en p-utf8
;	 Update 1.4	 	: 2007-05-23
;										Mise en place des PrototypeC
;  
; --------------------------------------------------------- 

; ---------------
;- Constantes
; ---------------

Enumeration 0 ; SQLite Constants
  #SQLITE_OK         =   0 ; Successful result 
  #SQLITE_ERROR      =   1 ; SQL error Or missing database 
  #SQLITE_INTERNAL   =   2 ; An internal logic error in SQLite 
  #SQLITE_PERM       =   3 ; Access permission denied 
  #SQLITE_ABORT      =   4 ; Callback routine requested an abort 
  #SQLITE_BUSY       =   5 ; The database file is locked 
  #SQLITE_LOCKED     =   6 ; A table in the database is locked 
  #SQLITE_NOMEM      =   7 ; A malloc() failed 
  #SQLITE_READONLY   =   8 ; Attempt To write a readonly database 
  #SQLITE_INTERRUPT  =   9 ; Operation terminated by sqlite_interrupt() 
  #SQLITE_IOERR      =  10 ; Some kind of disk I/O error occurred 
  #SQLITE_CORRUPT    =  11 ; The database disk image is malformed 
  #SQLITE_NOTFOUND   =  12 ; (Internal Only) Table Or record Not found 
  #SQLITE_FULL       =  13 ; Insertion failed because database is full 
  #SQLITE_CANTOPEN   =  14 ; Unable To open the database file 
  #SQLITE_PROTOCOL   =  15 ; Database lock protocol error 
  #SQLITE_EMPTY      =  16 ; (Internal Only) Database table is empty 
  #SQLITE_SCHEMA     =  17 ; The database schema changed 
  #SQLITE_TOOBIG     =  18 ; Too much Data For one row of a table 
  #SQLITE_CONSTRAINT =  19 ; Abort due To constraint violation 
  #SQLITE_MISMATCH   =  20 ; Data type mismatch 
  #SQLITE_MISUSE     =  21 ; Library used incorrectly 
  #SQLITE_NOLFS      =  22 ; Uses OS features Not supported on host 
  #SQLITE_AUTH       =  23 ; Authorization denied 
  #SQLITE_FORMAT     =  24 ; Auxiliary database format error
  #SQLITE_RANGE      =  25 ; 2nd parameter To sqlite3_bind out of range
  #SQLITE_NOTADB     =  26 ; File opened that is Not a database file
  #SQLITE_ROW        = 100 ; sqlite_step() has another row ready 
  #SQLITE_DONE       = 101 ; sqlite_step() has finished executing 
EndEnumeration
Enumeration 1 ; SQLite Types
  #SQLITE_INTEGER = 1 ; 
  #SQLITE_FLOAT   = 2 ; 
  #SQLITE_TEXT    = 3 ; 
  #SQLITE_BLOB    = 4 ; 
  #SQLITE_NULL    = 5 ; 
EndEnumeration
Enumeration 1 ; SQLite UTF
  #SQLITE_UTF8          = 1 ; 
  #SQLITE_UTF16LE       = 2 ;  
  #SQLITE_UTF16BE       = 3 ; 
  #SQLITE_UTF16         = 4 ; Use native byte order  
  #SQLITE_ANY           = 5 ; sqlite3_create_function only
  #SQLITE_UTF16_ALIGNED = 8 ; sqlite3_create_collation only
EndEnumeration
Enumeration 1 ; SQLite Operation
  #SQLITE_COPY                =  0 ; Table Name      File Name
  #SQLITE_CREATE_INDEX        =  1 ; Index Name      Table Name     
  #SQLITE_CREATE_TABLE        =  2 ; Table Name      NULL           
  #SQLITE_CREATE_TEMP_INDEX   =  3 ; Index Name      Table Name     
  #SQLITE_CREATE_TEMP_TABLE   =  4 ; Table Name      NULL           
  #SQLITE_CREATE_TEMP_TRIGGER =  5 ; Trigger Name    Table Name     
  #SQLITE_CREATE_TEMP_VIEW    =  6 ; View Name       NULL           
  #SQLITE_CREATE_TRIGGER      =  7 ; Trigger Name    Table Name     
  #SQLITE_CREATE_VIEW         =  8 ; View Name       NULL           
  #SQLITE_DELETE              =  9 ; Table Name      NULL           
  #SQLITE_DROP_INDEX          = 10 ; Index Name      Table Name     
  #SQLITE_DROP_TABLE          = 11 ; Table Name      NULL           
  #SQLITE_DROP_TEMP_INDEX     = 12 ; Index Name      Table Name     
  #SQLITE_DROP_TEMP_TABLE     = 13 ; Table Name      NULL           
  #SQLITE_DROP_TEMP_TRIGGER   = 14 ; Trigger Name    Table Name     
  #SQLITE_DROP_TEMP_VIEW      = 15 ; View Name       NULL           
  #SQLITE_DROP_TRIGGER        = 16 ; Trigger Name    Table Name     
  #SQLITE_DROP_VIEW           = 17 ; View Name       NULL           
  #SQLITE_INSERT              = 18 ; Table Name      NULL           
  #SQLITE_PRAGMA              = 19 ; Pragma Name     1st arg Or NULL
  #SQLITE_READ                = 20 ; Table Name      Column Name    
  #SQLITE_SELECT              = 21 ; NULL            NULL           
  #SQLITE_TRANSACTION         = 22 ; NULL            NULL           
  #SQLITE_UPDATE              = 23 ; Table Name      Column Name    
  #SQLITE_ATTACH              = 24 ; Filename        NULL           
  #SQLITE_DETACH              = 25 ; Database Name   NULL           
  #SQLITE_ALTER_TABLE         = 26 ; Database Name   Table Name     
  #SQLITE_REINDEX             = 27 ; Index Name      NULL           
  #SQLITE_ANALYZE             = 28 ; Table Name      NULL           
  #SQLITE_CREATE_VTABLE       = 29 ; Table Name      Module Name    
  #SQLITE_DROP_VTABLE         = 30 ; Table Name      Module Name    
  #SQLITE_FUNCTION            = 31 ; Function Name   NULL           
EndEnumeration
Enumeration 1 ; SQLite ?
  #SQLITE_STATIC    =  0 ; 
  #SQLITE_TRANSIENT = -1 ; 
EndEnumeration
Enumeration 1 ; SQLite ?
  #SQLITE_DENY   = 1 ; Abort the SQL statement With an error */
  #SQLITE_IGNORE = 2 ; Don't allow access, but don't generate an error */
EndEnumeration
Enumeration 1
  #SQLITE_INDEX_CONSTRAINT_EQ    = 2
  #SQLITE_INDEX_CONSTRAINT_GT    = 4
  #SQLITE_INDEX_CONSTRAINT_LE    = 8
  #SQLITE_INDEX_CONSTRAINT_LT    = 16
  #SQLITE_INDEX_CONSTRAINT_GE    = 32
  #SQLITE_INDEX_CONSTRAINT_MATCH = 64
EndEnumeration
; The extended result codes always have the primary result code
; As a prefix.  Primary result codes only contain a single "_"
; character.  Extended result codes contain two Or more "_" characters.
#SQLITE_IOERR_READ          = (#SQLITE_IOERR | (1<<8))
#SQLITE_IOERR_SHORT_READ    = (#SQLITE_IOERR | (2<<8))
#SQLITE_IOERR_WRITE         = (#SQLITE_IOERR | (3<<8))
#SQLITE_IOERR_FSYNC         = (#SQLITE_IOERR | (4<<8))
#SQLITE_IOERR_DIR_FSYNC     = (#SQLITE_IOERR | (5<<8))
#SQLITE_IOERR_TRUNCATE      = (#SQLITE_IOERR | (6<<8))
#SQLITE_IOERR_FSTAT         = (#SQLITE_IOERR | (7<<8))
#SQLITE_IOERR_UNLOCK        = (#SQLITE_IOERR | (8<<8))
#SQLITE_IOERR_RDLOCK        = (#SQLITE_IOERR | (9<<8))

; ---------------
;- Fonctions
; ---------------

Global SQLite3_DLL.l
CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    SQLite3_DLL = OpenLibrary(#PB_Any, "sqlite3.dll")
  CompilerCase #PB_OS_Linux
    SQLite3_DLL = OpenLibrary(#PB_Any, "libsqlite3.so")
  CompilerCase #PB_OS_MacOS
    SQLite3_DLL = OpenLibrary(#PB_Any, "/usr/lib/libsqlite3.dylib")
CompilerEndSelect

PrototypeC PROTO_sqlite3_aggregate_context(*sqlite3_context.l, nBytes.l)
PrototypeC PROTO_sqlite3_aggregate_count(*sqlite3_context.l) ; deprecated.
PrototypeC PROTO_sqlite3_bind_blob(*sqlite3_stmt.l, int1.l, *const, n.l, *void.l)
PrototypeC PROTO_sqlite3_bind_double(*sqlite3_stmt.l, int1.l, double.d)
PrototypeC PROTO_sqlite3_bind_int(*sqlite3_stmt.l, int1.l, int2.l)
PrototypeC PROTO_sqlite3_bind_int64(*sqlite3_stmt.l, int1.l, int2.q)
PrototypeC PROTO_sqlite3_bind_null(*sqlite3_stmt.l, int1.l)
PrototypeC PROTO_sqlite3_bind_parameter_count(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_bind_parameter_index(*sqlite3_stmt.l, name.p-utf8)
PrototypeC PROTO_sqlite3_bind_parameter_name(*sqlite3_stmt.l, n.l)
PrototypeC PROTO_sqlite3_bind_text(*sqlite3_stmt.l, int1.l, *char.l, n.l, *void.l)
PrototypeC PROTO_sqlite3_busy_handler(*sqlite3.l, *int.l, *void.l)
PrototypeC PROTO_sqlite3_busy_timeout(*sqlite3.l, ms.l)
PrototypeC PROTO_sqlite3_changes(*sqlite3.l)
PrototypeC PROTO_sqlite3_clear_bindings(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_close(*sqlite3.l)
PrototypeC PROTO_sqlite3_column_blob(*sqlite3_stmt.l, iCol.l)
PrototypeC PROTO_sqlite3_column_count(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_column_double(*sqlite3_stmt.l, iCol.l)
PrototypeC PROTO_sqlite3_column_int(*sqlite3_stmt.l, iCol.l)
PrototypeC PROTO_sqlite3_column_int64(*sqlite3_stmt.l, iCol.l)
PrototypeC PROTO_sqlite3_column_type(*sqlite3_stmt.l, iCol.l)
PrototypeC PROTO_sqlite3_column_bytes(*sqlite3_stmt.l, iCol.l)
PrototypeC PROTO_sqlite3_column_decltype(*sqlite3_stmt.l, i.l)
PrototypeC PROTO_sqlite3_column_name(*sqlite3_stmt.l, n.l)
PrototypeC PROTO_sqlite3_column_origin_name(*sqlite3_stmt.l, n.l)
PrototypeC PROTO_sqlite3_column_origin_name16(*sqlite3_stmt.l, n.l)
PrototypeC PROTO_sqlite3_column_text(*sqlite3_stmt.l, iCol.l)
PrototypeC PROTO_sqlite3_commit_hook(*sqlite3.l, *xCallback.l, *pArg.l)
PrototypeC PROTO_sqlite3_complete(sql.p-utf8)
PrototypeC PROTO_sqlite3_create_collation(*sqlite3.l, name.p-utf8, pref16.l, *void.l, *xCompare.l)
PrototypeC PROTO_sqlite3_create_function(*sqlite3.l, FunctionName.p-utf8, nArg.l, eTextRep.l, *pUserData.l, *xFunc.l, *xStep.l, *xFinal.l)
PrototypeC PROTO_sqlite3_collation_needed(*sqlite3.l, *void1, *void2)
PrototypeC PROTO_sqlite3_data_count(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_db_handle(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_enable_shared_cache(int.l)
PrototypeC PROTO_sqlite3_errcode(*sqlite3.l)
PrototypeC PROTO_sqlite3_errmsg(*sqlite3.l)
PrototypeC PROTO_sqlite3_exec(*sqlite3.l, sql.p-utf8, *callback.l, *argument.l, *errmsg.l)
PrototypeC PROTO_sqlite3_expired(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_finalize(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_free(*void.l)
PrototypeC PROTO_sqlite3_free_table(*result.l)
PrototypeC PROTO_sqlite3_get_autocommit(*sqlite3.l)
PrototypeC PROTO_sqlite3_get_auxdata(*sqlite3.l,int.l)
PrototypeC PROTO_sqlite3_get_table(*sqlite3.l, sql.p-utf8, *resultp.l, *nrow.l, *ncolumn.l, *errmsg.l)
PrototypeC PROTO_sqlite3_global_recover()
PrototypeC PROTO_sqlite3_interrupt(*sqlite3.l)
PrototypeC.q PROTO_sqlite3_last_insert_rowid(*sqlite3.l)
PrototypeC PROTO_sqlite3_libversion()
PrototypeC PROTO_sqlite3_libversion_number()
PrototypeC PROTO_sqlite3_mprintf(*void.l)
PrototypeC PROTO_sqlite3_open(filename.p-utf8, *handle.l)
PrototypeC PROTO_sqlite3_prepare(*sqlite3.l, sql.p-utf8, nBytes.l, *sqlite3_stmt.l, *pzTail.l)
PrototypeC PROTO_sqlite3_progress_handler(*sqlite3.l, int.l, *void1, *void2)
PrototypeC PROTO_sqlite3_release_memory(n.l)
PrototypeC PROTO_sqlite3_reset(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_result_blob(*sqlite3_context.l, *const, n.l, *void)
PrototypeC PROTO_sqlite3_result_double(*sqlite3_context.l, double.d)
PrototypeC PROTO_sqlite3_result_error(*sqlite3_context.l, *char.l, int.l)
PrototypeC PROTO_sqlite3_result_error16(*sqlite3_context.l, *void.l, int.l)
PrototypeC PROTO_sqlite3_result_int(*sqlite3_context.l, int.l)
PrototypeC PROTO_sqlite3_result_int64(*sqlite3_context.l, int.q)
PrototypeC PROTO_sqlite3_result_null(*sqlite3_context.l)
PrototypeC PROTO_sqlite3_result_text(*sqlite3_context.l, *char.l, n.l, *void.l)
PrototypeC PROTO_sqlite3_result_value(*sqlite3_context.l, *sqlite3_value.l)
PrototypeC PROTO_sqlite3_rollback_hook(*sqlite3.l, *void1.l, *void2.l)
PrototypeC PROTO_sqlite3_vmprintf(char.p-utf8, *va_list.l)
PrototypeC PROTO_sqlite3_set_authorizer(*sqlite3.l, *xAuth.l, *pUserData.l)
PrototypeC PROTO_sqlite3_set_auxdata(*sqlite3.l, int.l, *void1.l, *void2.l);***?
PrototypeC PROTO_sqlite3_snprintf(int.l, *char.l, *const.l);***?
PrototypeC PROTO_sqlite3_sleep(int.l)
PrototypeC PROTO_sqlite3_step(*sqlite3_stmt.l)
PrototypeC PROTO_sqlite3_soft_heap_limit(n.l)
PrototypeC PROTO_sqlite3_table_column_metadata(*sqlite3.l, DbName.p-utf8, TableName.p-utf8, ColumnName.p-utf8, DataType.p-utf8, CollSeq.p-utf8, *pNotNull, *pPrimaryKey, *pAutoinc)
PrototypeC PROTO_sqlite3_thread_cleanup()
PrototypeC PROTO_sqlite3_total_changes(*sqlite3.l)
PrototypeC PROTO_sqlite3_trace(*sqlite3.l, *xTrace.l, *void.l)
PrototypeC PROTO_sqlite3_transfer_bindings(*sqlite3_stmt.l, *sqlite3_stmt2.l)
PrototypeC PROTO_sqlite3_update_hook(*sqlite3.l, *void1.l, *void2.l)
PrototypeC PROTO_sqlite3_user_data(*sqlite3_context.l)
PrototypeC PROTO_sqlite3_value_blob(*sqlite3_value.l)
PrototypeC PROTO_sqlite3_value_bytes(*sqlite3_value.l)
PrototypeC PROTO_sqlite3_value_bytes16(*sqlite3_value.l)
PrototypeC PROTO_sqlite3_value_double(*sqlite3_value.l)
PrototypeC PROTO_sqlite3_value_int(*sqlite3_value.l)
PrototypeC PROTO_sqlite3_value_int64(*sqlite3_value.l)
PrototypeC PROTO_sqlite3_value_text(*sqlite3_value.l)
PrototypeC PROTO_sqlite3_value_type(*sqlite3_value.l)

Global sqlite3_aggregate_context.PROTO_sqlite3_aggregate_context = GetFunction(SQLite3_DLL, "sqlite3_aggregate_context")
Global sqlite3_aggregate_count.PROTO_sqlite3_aggregate_count = GetFunction(SQLite3_DLL, "sqlite3_aggregate_count")
Global sqlite3_bind_blob.PROTO_sqlite3_bind_blob = GetFunction(SQLite3_DLL, "sqlite3_bind_blob")
Global sqlite3_bind_double.PROTO_sqlite3_bind_double = GetFunction(SQLite3_DLL, "sqlite3_bind_double")
Global sqlite3_bind_int.PROTO_sqlite3_bind_int = GetFunction(SQLite3_DLL, "sqlite3_bind_int")
Global sqlite3_bind_int64.PROTO_sqlite3_bind_int64 = GetFunction(SQLite3_DLL, "sqlite3_bind_int64")
Global sqlite3_bind_null.PROTO_sqlite3_bind_null = GetFunction(SQLite3_DLL, "sqlite3_bind_null")
Global sqlite3_bind_parameter_count.PROTO_sqlite3_bind_parameter_count = GetFunction(SQLite3_DLL, "sqlite3_bind_parameter_count")
Global sqlite3_bind_parameter_index.PROTO_sqlite3_bind_parameter_index = GetFunction(SQLite3_DLL, "sqlite3_bind_parameter_index")
Global sqlite3_bind_parameter_name.PROTO_sqlite3_bind_parameter_name = GetFunction(SQLite3_DLL, "sqlite3_bind_parameter_name")
Global sqlite3_bind_text.PROTO_sqlite3_bind_text = GetFunction(SQLite3_DLL, "sqlite3_bind_text")
Global sqlite3_busy_handler.PROTO_sqlite3_busy_handler = GetFunction(SQLite3_DLL, "sqlite3_busy_handler")
Global sqlite3_busy_timeout.PROTO_sqlite3_busy_timeout = GetFunction(SQLite3_DLL, "sqlite3_busy_timeout")
Global sqlite3_changes.PROTO_sqlite3_changes = GetFunction(SQLite3_DLL, "sqlite3_changes")
Global sqlite3_clear_bindings.PROTO_sqlite3_clear_bindings = GetFunction(SQLite3_DLL, "sqlite3_clear_bindings")
Global sqlite3_close.PROTO_sqlite3_close = GetFunction(SQLite3_DLL, "sqlite3_close")
Global sqlite3_column_blob.PROTO_sqlite3_column_blob = GetFunction(SQLite3_DLL, "sqlite3_column_blob")
Global sqlite3_column_count.PROTO_sqlite3_column_count = GetFunction(SQLite3_DLL, "sqlite3_column_count")
Global sqlite3_column_double.PROTO_sqlite3_column_double = GetFunction(SQLite3_DLL, "sqlite3_column_double")
Global sqlite3_column_int.PROTO_sqlite3_column_int = GetFunction(SQLite3_DLL, "sqlite3_column_int")
Global sqlite3_column_int64.PROTO_sqlite3_column_int64 = GetFunction(SQLite3_DLL, "sqlite3_column_int64")
Global sqlite3_column_type.PROTO_sqlite3_column_type = GetFunction(SQLite3_DLL, "sqlite3_column_type")
Global sqlite3_column_bytes.PROTO_sqlite3_column_bytes = GetFunction(SQLite3_DLL, "sqlite3_column_bytes")
Global sqlite3_column_decltype.PROTO_sqlite3_column_decltype = GetFunction(SQLite3_DLL, "sqlite3_column_decltype")
Global sqlite3_column_name.PROTO_sqlite3_column_name = GetFunction(SQLite3_DLL, "sqlite3_column_name")
Global sqlite3_column_origin_name.PROTO_sqlite3_column_origin_name = GetFunction(SQLite3_DLL, "sqlite3_column_origin_name")
Global sqlite3_column_origin_name16.PROTO_sqlite3_column_origin_name16 = GetFunction(SQLite3_DLL, "sqlite3_column_origin_name16")
Global sqlite3_column_text.PROTO_sqlite3_column_text = GetFunction(SQLite3_DLL, "sqlite3_column_text")
Global sqlite3_commit_hook.PROTO_sqlite3_commit_hook = GetFunction(SQLite3_DLL, "sqlite3_commit_hook")
Global sqlite3_complete.PROTO_sqlite3_complete = GetFunction(SQLite3_DLL, "sqlite3_complete")
Global sqlite3_create_collation.PROTO_sqlite3_create_collation = GetFunction(SQLite3_DLL, "sqlite3_create_collation")
Global sqlite3_create_function.PROTO_sqlite3_create_function = GetFunction(SQLite3_DLL, "sqlite3_create_function")
Global sqlite3_collation_needed.PROTO_sqlite3_collation_needed = GetFunction(SQLite3_DLL, "sqlite3_collation_needed")
Global sqlite3_data_count.PROTO_sqlite3_data_count = GetFunction(SQLite3_DLL, "sqlite3_data_count")
Global sqlite3_db_handle.PROTO_sqlite3_db_handle = GetFunction(SQLite3_DLL, "sqlite3_db_handle")
Global sqlite3_enable_shared_cache.PROTO_sqlite3_enable_shared_cache = GetFunction(SQLite3_DLL, "sqlite3_enable_shared_cache")
Global sqlite3_errcode.PROTO_sqlite3_errcode = GetFunction(SQLite3_DLL, "sqlite3_errcode")
Global sqlite3_errmsg.PROTO_sqlite3_errmsg = GetFunction(SQLite3_DLL, "sqlite3_errmsg")
Global sqlite3_exec.PROTO_sqlite3_exec = GetFunction(SQLite3_DLL, "sqlite3_exec")
Global sqlite3_expired.PROTO_sqlite3_expired = GetFunction(SQLite3_DLL, "sqlite3_expired")
Global sqlite3_finalize.PROTO_sqlite3_finalize = GetFunction(SQLite3_DLL, "sqlite3_finalize")
Global sqlite3_free.PROTO_sqlite3_free = GetFunction(SQLite3_DLL, "sqlite3_free")
Global sqlite3_free_table.PROTO_sqlite3_free_table = GetFunction(SQLite3_DLL, "sqlite3_free_table")
Global sqlite3_get_autocommit.PROTO_sqlite3_get_autocommit = GetFunction(SQLite3_DLL, "sqlite3_get_autocommit")
Global sqlite3_get_auxdata.PROTO_sqlite3_get_auxdata = GetFunction(SQLite3_DLL, "sqlite3_get_auxdata")
Global sqlite3_get_table.PROTO_sqlite3_get_table = GetFunction(SQLite3_DLL, "sqlite3_get_table")
Global sqlite3_global_recover.PROTO_sqlite3_global_recover = GetFunction(SQLite3_DLL, "sqlite3_global_recover")
Global sqlite3_interrupt.PROTO_sqlite3_interrupt = GetFunction(SQLite3_DLL, "sqlite3_interrupt")
Global sqlite3_last_insert_rowid.PROTO_sqlite3_last_insert_rowid = GetFunction(SQLite3_DLL, "sqlite3_last_insert_rowid")
Global sqlite3_libversion.PROTO_sqlite3_libversion = GetFunction(SQLite3_DLL, "sqlite3_libversion")
Global sqlite3_libversion_number.PROTO_sqlite3_libversion_number = GetFunction(SQLite3_DLL, "sqlite3_libversion_number")
Global sqlite3_mprintf.PROTO_sqlite3_mprintf = GetFunction(SQLite3_DLL, "sqlite3_mprintf")
Global sqlite3_open.PROTO_sqlite3_open = GetFunction(SQLite3_DLL, "sqlite3_open")
Global sqlite3_prepare.PROTO_sqlite3_prepare = GetFunction(SQLite3_DLL, "sqlite3_prepare")
Global sqlite3_progress_handler.PROTO_sqlite3_progress_handler = GetFunction(SQLite3_DLL, "sqlite3_progress_handler")
Global sqlite3_release_memory.PROTO_sqlite3_release_memory = GetFunction(SQLite3_DLL, "sqlite3_release_memory")
Global sqlite3_reset.PROTO_sqlite3_reset = GetFunction(SQLite3_DLL, "sqlite3_reset")
Global sqlite3_result_blob.PROTO_sqlite3_result_blob = GetFunction(SQLite3_DLL, "sqlite3_result_blob")
Global sqlite3_result_double.PROTO_sqlite3_result_double = GetFunction(SQLite3_DLL, "sqlite3_result_double")
Global sqlite3_result_error.PROTO_sqlite3_result_error = GetFunction(SQLite3_DLL, "sqlite3_result_error")
Global sqlite3_result_error16.PROTO_sqlite3_result_error16 = GetFunction(SQLite3_DLL, "sqlite3_result_error16")
Global sqlite3_result_int.PROTO_sqlite3_result_int = GetFunction(SQLite3_DLL, "sqlite3_result_int")
Global sqlite3_result_int64.PROTO_sqlite3_result_int64 = GetFunction(SQLite3_DLL, "sqlite3_result_int64")
Global sqlite3_result_null.PROTO_sqlite3_result_null = GetFunction(SQLite3_DLL, "sqlite3_result_null")
Global sqlite3_result_text.PROTO_sqlite3_result_text = GetFunction(SQLite3_DLL, "sqlite3_result_text")
Global sqlite3_result_value.PROTO_sqlite3_result_value = GetFunction(SQLite3_DLL, "sqlite3_result_value")
Global sqlite3_rollback_hook.PROTO_sqlite3_rollback_hook = GetFunction(SQLite3_DLL, "sqlite3_rollback_hook")
Global sqlite3_vmprintf.PROTO_sqlite3_vmprintf = GetFunction(SQLite3_DLL, "sqlite3_vmprintf")
Global sqlite3_set_authorizer.PROTO_sqlite3_set_authorizer = GetFunction(SQLite3_DLL, "sqlite3_set_authorizer")
Global sqlite3_set_auxdata.PROTO_sqlite3_set_auxdata = GetFunction(SQLite3_DLL, "sqlite3_set_auxdata")
Global sqlite3_snprintf.PROTO_sqlite3_snprintf = GetFunction(SQLite3_DLL, "sqlite3_snprintf")
Global sqlite3_sleep.PROTO_sqlite3_sleep = GetFunction(SQLite3_DLL, "sqlite3_sleep")
Global sqlite3_step.PROTO_sqlite3_step = GetFunction(SQLite3_DLL, "sqlite3_step")
Global sqlite3_soft_heap_limit.PROTO_sqlite3_soft_heap_limit = GetFunction(SQLite3_DLL, "sqlite3_soft_heap_limit")
Global sqlite3_table_column_metadata.PROTO_sqlite3_table_column_metadata = GetFunction(SQLite3_DLL, "sqlite3_table_column_metadata")
Global sqlite3_thread_cleanup.PROTO_sqlite3_thread_cleanup = GetFunction(SQLite3_DLL, "sqlite3_thread_cleanup")
Global sqlite3_total_changes.PROTO_sqlite3_total_changes = GetFunction(SQLite3_DLL, "sqlite3_total_changes")
Global sqlite3_trace.PROTO_sqlite3_trace = GetFunction(SQLite3_DLL, "sqlite3_trace")
Global sqlite3_transfer_bindings.PROTO_sqlite3_transfer_bindings = GetFunction(SQLite3_DLL, "sqlite3_transfer_bindings")
Global sqlite3_update_hook.PROTO_sqlite3_update_hook = GetFunction(SQLite3_DLL, "sqlite3_update_hook")
Global sqlite3_user_data.PROTO_sqlite3_user_data = GetFunction(SQLite3_DLL, "sqlite3_user_data")
Global sqlite3_value_blob.PROTO_sqlite3_value_blob = GetFunction(SQLite3_DLL, "sqlite3_value_blob")
Global sqlite3_value_bytes.PROTO_sqlite3_value_bytes = GetFunction(SQLite3_DLL, "sqlite3_value_bytes")
Global sqlite3_value_bytes16.PROTO_sqlite3_value_bytes16 = GetFunction(SQLite3_DLL, "sqlite3_value_bytes16")
Global sqlite3_value_double.PROTO_sqlite3_value_double = GetFunction(SQLite3_DLL, "sqlite3_value_double")
Global sqlite3_value_int.PROTO_sqlite3_value_int = GetFunction(SQLite3_DLL, "sqlite3_value_int")
Global sqlite3_value_int64.PROTO_sqlite3_value_int64 = GetFunction(SQLite3_DLL, "sqlite3_value_int64")
Global sqlite3_value_text.PROTO_sqlite3_value_text = GetFunction(SQLite3_DLL, "sqlite3_value_text")
Global sqlite3_value_type.PROTO_sqlite3_value_type = GetFunction(SQLite3_DLL, "sqlite3_value_type")





; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 150
; FirstLine = 129
; Folding = --
; EnableXP
; UseMainFile = SQLite_Ex0.pb