﻿IncludeFile "Inc_SQLite.pb"
IncludeFile "Inc_Functions.pb"

Global DBTest.l

Procedure DBG(foo.s, filename.s="Test_ex_log.txt")
	Protected hFile.l
	If #PB_Compiler_Debugger = 0
		If FileSize(filename) = -1
		  hFile = CreateFile(#PB_Any, filename)
		Else
		  hFile = OpenFile(#PB_Any, filename)
		EndIf
		If hFile = 0
		  MessageRequester("ERROR","Can't create the log file >"+filename+"< !")
		  End
		Else
		  If foo <> ""
		    FileSeek(hFile, FileSize(filename))
		    WriteString	(hFile, foo)
		    WriteStringN(hFile, "")
		  EndIf
		  CloseFile(hFile)
		EndIf
  Else
  	Debug foo
  EndIf
EndProcedure
Procedure.s MD5(pass.s)
  *Buffer=AllocateMemory(Len(pass)+1)
  PokeS(*Buffer,pass, Len(pass), #PB_Ascii)
  MD5Fingerprint.s = MD5Fingerprint(*Buffer, Len(pass))
  FreeMemory(*Buffer)
  ProcedureReturn MD5Fingerprint
EndProcedure
DBG("Version : " +  SQLite_GetLibVersion())

SQLite_InitDatabase()
DBTest = SQLite_OpenDatabase(2,"test_ex0.sdb")
; pour le requester, décommentez la ligne suivante
;DBTest = SQLite_OpenDatabaseRequester(2)
Debug DBTest
DBG(Str(DBTest))
DBG(Str(SQLite_IsDatabase(2))) 
DBG("=== DEBUT ===")
If DBTest
	DBG("==== DB Opened")
	DBG("/////////////////////////")
	DBG("///// 1 - Update  DB ////")
	DBG("/////////////////////////")
	;{
		SQLite_DatabaseUpdate(2, "CREATE TABLE 'users'('id' tinyint(4) Not NULL,'username' varchar(20) Not NULL,'password' varchar(50) Not NULL,  PRIMARY KEY  ('id'));")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
		DBG("-----------")
	
		SQLite_DatabaseUpdate(2, "INSERT INTO 'users' VALUES (0, 'user_0', '"+MD5("pass_0")+"');")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
		DBG("-----------")
	
		SQLite_DatabaseUpdate(2, "INSERT INTO 'users' VALUES (1, 'user_1', '"+MD5("pass_1")+"');")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
		DBG("-----------")
	
		SQLite_DatabaseUpdate(2, "INSERT INTO 'users' VALUES (2, 'user_2', '"+MD5("pass_2")+"');")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
		DBG("-----------")
	
		SQLite_DatabaseUpdate(2, "INSERT INTO 'users' VALUES (3, 'user_3', '"+MD5("pass_3")+"');")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
		DBG("-----------")
	
		SQLite_DatabaseUpdate(2, "UPDATE users SET username = 'user_update' WHERE id = 1;")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
	;}
	
	DBG("/////////////////////////")
	DBG("///// 2 - Query DB //////")
	DBG("/////////////////////////")
	;{
		SQLite_DatabaseQuery(2, "SELECT * FROM 'users';")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
		DBG("================")
		For i=0 To SQLite_DatabaseColumns(2)-1
			DBG(SQLite_DatabaseColumnName(2,i) + " - Type : " + Str(SQLite_DatabaseColumnType(2,i)))
		Next
		DBG("================")
	 	For i=0 To SQLite_DatabaseColumns(2)-1
	 		SQLite_FirstDatabaseRow(2)
	 		For Rows = 0 To SQLite_DatabaseRows(2)-1
				Select SQLite_DatabaseColumnType(2,i)
	 				Case 0
						DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Blob : "+PeekS(SQLite_GetDatabaseBlob(2, i)))
	 				Case 1
	 					DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Long : "+Str(SQLite_GetDatabaseLong(2, i)))
	 				Case 2
	 					DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Chaine : "+SQLite_GetDatabaseString(2, i))
					Case 3
	 					DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Float : "+Str(SQLite_GetDatabaseFloat(2, i)))
	 			EndSelect 
	 			SQLite_NextDatabaseRow(2)
	 		Next
	 		DBG("++++++++++++++++")
	 	Next
		DBG("================")
		
		SQLite_DatabaseQuery(2, "SELECT id,username FROM 'users' WHERE id >= 2;")
		DBG(SQLite_DatabaseError())
		DBG("Columns :"+Str(SQLite_DatabaseColumns(2)))
		DBG("Rows :"+Str(SQLite_DatabaseRows(2)))
		DBG("================")
		For i=0 To SQLite_DatabaseColumns(2)-1
			DBG(SQLite_DatabaseColumnName(2,i) + " - Type : " + Str(SQLite_DatabaseColumnType(2,i)))
		Next
		DBG("================")
	 	For i=0 To SQLite_DatabaseColumns(2)-1
	 		SQLite_FirstDatabaseRow(2)
	 		For Rows = 0 To SQLite_DatabaseRows(2)-1
				Select SQLite_DatabaseColumnType(2,i)
	 				Case 0
	 					DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Blob : "+PeekS(SQLite_GetDatabaseBlob(2, i)))
	 				Case 1
	 					DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Long : "+Str(SQLite_GetDatabaseLong(2, i)))
	 				Case 2
	 					DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Chaine : "+SQLite_GetDatabaseString(2, i))
					Case 3
	 					DBG("Position : "+Str(SQLite_GetDatabaseRowState(2))+" / Float : "+Str(SQLite_GetDatabaseFloat(2, i)))
	 			EndSelect 
	 			SQLite_NextDatabaseRow(2)
	 		Next
	 		DBG("++++++++++++++++")
	 	Next
		DBG("================")
	;}

	DBG("/////////////////////////")
	DBG("///// 3 - DB Tables /////")
	DBG("/////////////////////////")
	;{
		NbTables = SQLite_ExamineDatabaseTables(2)
		SQLite_FirstDatabaseTable(2)
		For i = 0 To NbTables - 1
			DBG("Position : " + Str(i) + " - Nom : '" + SQLite_DatabaseTable(2) + "'")
			SQLite_NextDatabaseTable(2)
		Next
		DBG("================")
	;}
	
	If SQLite_CloseDatabase(2)
		DBG("==== DB Closed")
	EndIf
EndIf
DBG("=== FIN ===")


; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 31
; Folding = +
; Executable = test_ex01.exe
; DisableDebugger
; EnableCompileCount = 15
; EnableBuildCount = 0